<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/ads/googleads/v9/resources/asset_set.proto

namespace Google\Ads\GoogleAds\V9\Resources;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * An asset set representing a collection of assets.
 * Use AssetSetAsset to link an asset to the asset set.
 *
 * Generated from protobuf message <code>google.ads.googleads.v9.resources.AssetSet</code>
 */
class AssetSet extends \Google\Protobuf\Internal\Message
{
    /**
     * Immutable. The resource name of the asset set.
     * Asset set resource names have the form:
     * `customers/{customer_id}/assetSets/{asset_set_id}`
     *
     * Generated from protobuf field <code>string resource_name = 1 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     */
    protected $resource_name = '';
    /**
     * Required. Name of the asset set. Required. It must have a minimum length of 1 and
     * maximum length of 128.
     *
     * Generated from protobuf field <code>string name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     */
    protected $name = '';
    /**
     * Required. Immutable. The type of the asset set. Required.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.enums.AssetSetTypeEnum.AssetSetType type = 3 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     */
    protected $type = 0;
    /**
     * Output only. The status of the asset set. Read-only.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.enums.AssetSetStatusEnum.AssetSetStatus status = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     */
    protected $status = 0;
    /**
     * Merchant ID and Feed Label from Google Merchant Center.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.resources.AssetSet.MerchantCenterFeed merchant_center_feed = 5;</code>
     */
    protected $merchant_center_feed = null;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type string $resource_name
     *           Immutable. The resource name of the asset set.
     *           Asset set resource names have the form:
     *           `customers/{customer_id}/assetSets/{asset_set_id}`
     *     @type string $name
     *           Required. Name of the asset set. Required. It must have a minimum length of 1 and
     *           maximum length of 128.
     *     @type int $type
     *           Required. Immutable. The type of the asset set. Required.
     *     @type int $status
     *           Output only. The status of the asset set. Read-only.
     *     @type \Google\Ads\GoogleAds\V9\Resources\AssetSet\MerchantCenterFeed $merchant_center_feed
     *           Merchant ID and Feed Label from Google Merchant Center.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Ads\GoogleAds\V9\Resources\AssetSet::initOnce();
        parent::__construct($data);
    }

    /**
     * Immutable. The resource name of the asset set.
     * Asset set resource names have the form:
     * `customers/{customer_id}/assetSets/{asset_set_id}`
     *
     * Generated from protobuf field <code>string resource_name = 1 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @return string
     */
    public function getResourceName()
    {
        return $this->resource_name;
    }

    /**
     * Immutable. The resource name of the asset set.
     * Asset set resource names have the form:
     * `customers/{customer_id}/assetSets/{asset_set_id}`
     *
     * Generated from protobuf field <code>string resource_name = 1 [(.google.api.field_behavior) = IMMUTABLE, (.google.api.resource_reference) = {</code>
     * @param string $var
     * @return $this
     */
    public function setResourceName($var)
    {
        GPBUtil::checkString($var, True);
        $this->resource_name = $var;

        return $this;
    }

    /**
     * Required. Name of the asset set. Required. It must have a minimum length of 1 and
     * maximum length of 128.
     *
     * Generated from protobuf field <code>string name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @return string
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Required. Name of the asset set. Required. It must have a minimum length of 1 and
     * maximum length of 128.
     *
     * Generated from protobuf field <code>string name = 2 [(.google.api.field_behavior) = REQUIRED];</code>
     * @param string $var
     * @return $this
     */
    public function setName($var)
    {
        GPBUtil::checkString($var, True);
        $this->name = $var;

        return $this;
    }

    /**
     * Required. Immutable. The type of the asset set. Required.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.enums.AssetSetTypeEnum.AssetSetType type = 3 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @return int
     */
    public function getType()
    {
        return $this->type;
    }

    /**
     * Required. Immutable. The type of the asset set. Required.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.enums.AssetSetTypeEnum.AssetSetType type = 3 [(.google.api.field_behavior) = REQUIRED, (.google.api.field_behavior) = IMMUTABLE];</code>
     * @param int $var
     * @return $this
     */
    public function setType($var)
    {
        GPBUtil::checkEnum($var, \Google\Ads\GoogleAds\V9\Enums\AssetSetTypeEnum\AssetSetType::class);
        $this->type = $var;

        return $this;
    }

    /**
     * Output only. The status of the asset set. Read-only.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.enums.AssetSetStatusEnum.AssetSetStatus status = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @return int
     */
    public function getStatus()
    {
        return $this->status;
    }

    /**
     * Output only. The status of the asset set. Read-only.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.enums.AssetSetStatusEnum.AssetSetStatus status = 4 [(.google.api.field_behavior) = OUTPUT_ONLY];</code>
     * @param int $var
     * @return $this
     */
    public function setStatus($var)
    {
        GPBUtil::checkEnum($var, \Google\Ads\GoogleAds\V9\Enums\AssetSetStatusEnum\AssetSetStatus::class);
        $this->status = $var;

        return $this;
    }

    /**
     * Merchant ID and Feed Label from Google Merchant Center.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.resources.AssetSet.MerchantCenterFeed merchant_center_feed = 5;</code>
     * @return \Google\Ads\GoogleAds\V9\Resources\AssetSet\MerchantCenterFeed|null
     */
    public function getMerchantCenterFeed()
    {
        return $this->merchant_center_feed;
    }

    public function hasMerchantCenterFeed()
    {
        return isset($this->merchant_center_feed);
    }

    public function clearMerchantCenterFeed()
    {
        unset($this->merchant_center_feed);
    }

    /**
     * Merchant ID and Feed Label from Google Merchant Center.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v9.resources.AssetSet.MerchantCenterFeed merchant_center_feed = 5;</code>
     * @param \Google\Ads\GoogleAds\V9\Resources\AssetSet\MerchantCenterFeed $var
     * @return $this
     */
    public function setMerchantCenterFeed($var)
    {
        GPBUtil::checkMessage($var, \Google\Ads\GoogleAds\V9\Resources\AssetSet\MerchantCenterFeed::class);
        $this->merchant_center_feed = $var;

        return $this;
    }

}

